#ifndef SETTINGS_H
#define SETTINGS_H

#include <QDialog>
#include <QString>
#include <QAudioDeviceInfo>

namespace Ui {
    class Settings;
}

class Settings : public QDialog
{
    Q_OBJECT

public:
    explicit Settings(QWidget *parent = 0);
    ~Settings();
    void setSource(QString source);
    void setRate(int rate);
    void setChannels(int channels);
    void setSoundActivated(bool soundactivated);
    void setStartLevel(int startlevel);
    void setStartTime(int starttime);
    void setStopLevel(int stoplevel);
    void setStopTime(int stoptime);
    void setSaveFolder(QString savefolder);
    void setMP3Channels(int index);
    void setMP3Frequency(int index);
    void setMP3Bitrate(int index);
    void setMP3Encoding(int index);
    void setMP3Quality(int index);
    QString getSource(void);
    int getRate(void);
    int getChannels(void);
    bool getSoundActivated(void);
    int getStartLevel(void);
    int getStartTime(void);
    int getStopLevel(void);
    int getStopTime(void);
    QString getSaveFolder(void);
    int getMP3Channels(void);
    int getMP3Frequency(void);
    int getMP3Bitrate(void);
    int getMP3Encoding(void);
    int getMP3Quality(void);

public slots:
    void doBrowseSaveFolder(void);
    void deviceSelected(int index);

private:
    Ui::Settings *ui;
    QList<QAudioDeviceInfo> devices;
    void enumerateSoundCards(void);
    // persistant settings data
    QString currentsource;
    int currentrate;
    int currentchannels;
    // end persistant settings data
};

#endif // SETTINGS_H
